/* termios type and macro definitions.  Linux/MIPS version.
Copyright (C) 1993, 1994, 1995 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#ifndef _TERMBITS_H

/* Any one of these symbols __need_* means that GNU libc
   wants us just to define one data type.  So don't define
   the symbols that indicate this file's entire job has been done.  */
#if !defined(__need_termbits_types)
#define _TERMBITS_H
#endif

/*
 * Dirty: These should actually come from <linux/types.h> and <asm/types.h> ...
 */
#if	!defined (__termbits_types_defined) && \
	(defined(_TERMBITS_H) || defined(__need_termbits_types))
#define __termbits_types_defined

/* Type of terminal control flag masks.  */
typedef unsigned int tcflag_t;

/* Type of control characters.  */
typedef unsigned char cc_t;

/* Type of baud rate specifiers.  */
typedef unsigned int speed_t;

#endif /* need termbits_types */
#undef __need_termbits_types

#if defined (_TERMBITS_H)

/* Get the complete termios stuff from the kernel header file.  We also
   get some stuff from there that shouldn't be included via this file
   but some code expects sys/termios.h to have it ...  */
#include <asm/termios.h>

#define _IOT_termios /* Hurd ioctl type field.  */ \
  _IOT (_IOTS (cflag_t), 4, _IOTS (cc_t), NCCS, _IOTS (speed_t), 2)

#endif /* defined (_TERMBITS_H) */

#endif /* !defined (_TERMBITS_H) */
